package xyz.stachel.zombiesutils.game.waves;

import xyz.stachel.zombiesutils.ZombiesUtils;
import xyz.stachel.zombiesutils.utils.Scoreboard;
import net.minecraft.client.Minecraft;

import java.util.Arrays;

public class WaveTiming {
    private int rlSetting;
    public int rl = 0;

    public WaveTiming() {
       this.rlSetting = ZombiesUtils.getInstance().getConfig().getOffset();
    }

    public void onTick() {
        if (Scoreboard.isNotZombies()) return;
        ZombiesUtils.getInstance().getGameManager().getGame().ifPresent(
                game -> {
                    short[] waves = ZombiesUtils.getInstance().getGameData().getRound(game.getGameMode(), game.getRound()).getWaveTimes();
                    final int roundTime = game.getTimer().getRoundTime();
                    final int[] auditory = ZombiesUtils.getInstance().getConfig().getAuditory();
                    for (short wave : waves) {
                        wave = (short) (wave + rl);
                        final Integer pre = roundTime - wave;
                        if (Arrays.stream(auditory).anyMatch(pre::equals)) {
                            Minecraft.getMinecraft().thePlayer.playSound("note.pling", 1, 2);
                        }
                    }
                }
        );
    }

    public void toggleRL() {
        if (rl == 0) rl = rlSetting;
        else rl = 0;
    }

    public void setRlTemp(final int ticks) {
      this.rlSetting = ticks;
    }
}
